Open Lighting Architecture: ola::Plugin Class Reference

| Open Lighting Architecture 0.10.9

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Protected Attributes | Static Protected Attributes | List of all members
ola::Plugin Class Referenceabstract
Inheritance diagram for ola::Plugin:

## Public Member Functions
| Plugin (PluginAdaptor *plugin_adaptor)
bool | LoadPreferences ()
| Load the preferences for a plugin and set defaults.
std::string | PreferenceConfigLocation () const
| The location for preferences.
bool | IsEnabled () const
| Is the plugin enabled?
void | SetEnabledState (bool enable)
| Set the plugin's enabled state.
virtual bool | Start ()
| Start the plugin.
virtual bool | Stop ()
| Stop the plugin.
virtual bool | DefaultMode () const
virtual ola_plugin_id | Id () const =0
| Get the plugin ID of this plugin.
virtual std::string | PluginPrefix () const =0
| The prefix to use for storing configuration files.
virtual void | ConflictsWith (std::set< ola_plugin_id > *) const
bool | operator< (const AbstractPlugin &other) const
Public Member Functions inherited from ola::AbstractPlugin
virtual std::string | Name () const =0
| Get the plugin name.
virtual std::string | Description () const =0

## Protected Member Functions
virtual bool | StartHook ()
virtual bool | StopHook ()
virtual bool | SetDefaultPreferences ()

## Protected Attributes
PluginAdaptor * | m_plugin_adaptor
class Preferences * | m_preferences

## Static Protected Attributes
static const char | ENABLED_KEY [] = "enabled"

## Member Function Documentation

## ◆ ConflictsWith()

virtual void ola::Plugin::ConflictsWith | ( | std::set< ola_plugin_id > * |  | ) | const
| inlinevirtual

Implements ola::AbstractPlugin.

## ◆ Id()

virtual ola_plugin_id ola::Plugin::Id | ( |  | ) | const
| pure virtual

Get the plugin ID of this plugin.

Returns
  the ola_plugin_id of this plugin

Implements ola::AbstractPlugin.

Implemented in ola::plugin::artnet::ArtNetPlugin, ola::plugin::dmx4linux::Dmx4LinuxPlugin, ola::plugin::dummy::DummyPlugin, ola::plugin::e131::E131Plugin, ola::plugin::espnet::EspNetPlugin, ola::plugin::ftdidmx::FtdiDmxPlugin, ola::plugin::gpio::GPIOPlugin, ola::plugin::karate::KaratePlugin, ola::plugin::kinet::KiNetPlugin, ola::plugin::milinst::MilInstPlugin, ola::plugin::opendmx::OpenDmxPlugin, ola::plugin::openpixelcontrol::OPCPlugin, ola::plugin::osc::OSCPlugin, ola::plugin::pathport::PathportPlugin, ola::plugin::renard::RenardPlugin, ola::plugin::sandnet::SandNetPlugin, ola::plugin::shownet::ShowNetPlugin, ola::plugin::spi::SPIPlugin, ola::plugin::stageprofi::StageProfiPlugin, ola::plugin::uartdmx::UartDmxPlugin, ola::plugin::usbdmx::UsbDmxPlugin, and ola::plugin::usbpro::UsbSerialPlugin.

## ◆ IsEnabled()

bool ola::Plugin::IsEnabled | ( |  | ) | const
| virtual

Is the plugin enabled?

Returns
  true if this plugin is enabled

Implements ola::AbstractPlugin.

## ◆ LoadPreferences()

bool ola::Plugin::LoadPreferences | ( |  | ) |
| virtual

Load the preferences for a plugin and set defaults.

Implements ola::AbstractPlugin.

## ◆ operator<()

bool ola::Plugin::operator< | ( | const AbstractPlugin & | other | ) | const
| inlinevirtual

Implements ola::AbstractPlugin.

## ◆ PluginPrefix()

virtual std::string ola::Plugin::PluginPrefix | ( |  | ) | const
| pure virtual

The prefix to use for storing configuration files.

Returns
  A unique prefix used to identify the configuration file for this plugin.

Implemented in ola::plugin::artnet::ArtNetPlugin, ola::plugin::dmx4linux::Dmx4LinuxPlugin, ola::plugin::dummy::DummyPlugin, ola::plugin::e131::E131Plugin, ola::plugin::espnet::EspNetPlugin, ola::plugin::ftdidmx::FtdiDmxPlugin, ola::plugin::gpio::GPIOPlugin, ola::plugin::karate::KaratePlugin, ola::plugin::kinet::KiNetPlugin, ola::plugin::milinst::MilInstPlugin, ola::plugin::opendmx::OpenDmxPlugin, ola::plugin::openpixelcontrol::OPCPlugin, ola::plugin::osc::OSCPlugin, ola::plugin::pathport::PathportPlugin, ola::plugin::renard::RenardPlugin, ola::plugin::sandnet::SandNetPlugin, ola::plugin::shownet::ShowNetPlugin, ola::plugin::spi::SPIPlugin, ola::plugin::stageprofi::StageProfiPlugin, ola::plugin::uartdmx::UartDmxPlugin, ola::plugin::usbdmx::UsbDmxPlugin, and ola::plugin::usbpro::UsbSerialPlugin.

## ◆ PreferenceConfigLocation()

string ola::Plugin::PreferenceConfigLocation | ( |  | ) | const
| virtual

The location for preferences.

This can be anything really but should indicate to the user how the preferences were loaded.

Implements ola::AbstractPlugin.

## ◆ SetDefaultPreferences()

virtual bool ola::Plugin::SetDefaultPreferences | ( |  | ) |
| inlineprotectedvirtual

Set default preferences.

## ◆ SetEnabledState()

void ola::Plugin::SetEnabledState | ( | bool | enable | ) |
| virtual

Set the plugin's enabled state.

Parameters

  enable | The new enabled state

Returns
  true if this plugin is enabled

Implements ola::AbstractPlugin.

## ◆ Start()

bool ola::Plugin::Start | ( |  | ) |
| virtual

Start the plugin.

Calls StartHook() which can be overridden by the derived classes.

Returns
  true if we started ok, false otherwise

Implements ola::AbstractPlugin.

## ◆ Stop()

bool ola::Plugin::Stop | ( |  | ) |
| virtual

Stop the plugin.

Calls StopHook() which can be overridden by the derived classes.

Returns
  true on success, false on failure

Implements ola::AbstractPlugin.

The documentation for this class was generated from the following files:

- include/olad/Plugin.h
- olad/plugin_api/Plugin.cpp